diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index 31187a773..e202cfca4 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -19,14 +19,25 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityBobber;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.EntityLightningBolt;
 import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.EntityTNT;
 import net.minecraft.core.entity.animal.EntityPig;
 import net.minecraft.core.entity.animal.EntityWolf;
 import net.minecraft.core.entity.monster.EntityCreeper;
 import net.minecraft.core.entity.monster.EntityGhast;
+import net.minecraft.core.entity.monster.EntityGiant;
 import net.minecraft.core.entity.monster.EntityMonster;
+import net.minecraft.core.entity.monster.EntityPigZombie;
+import net.minecraft.core.entity.monster.EntitySkeleton;
+import net.minecraft.core.entity.monster.EntitySlime;
 import net.minecraft.core.entity.monster.EntitySnowman;
+import net.minecraft.core.entity.monster.EntitySpider;
+import net.minecraft.core.entity.monster.EntityZombie;
 import net.minecraft.core.entity.projectile.EntityArrow;
+import net.minecraft.core.entity.projectile.EntityArrowGolden;
+import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.entity.projectile.EntityFireball;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.ArtType;
@@ -50,6 +61,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weather;
+import net.minecraft.server.entity.player.EntityPlayerMP;
 
 import java.util.ArrayList;
 import java.util.Comparator;
@@ -58,6 +70,7 @@ import java.util.List;
 
 public abstract class EntityPlayer extends EntityLiving
 {
+    public static final TextFormatting deathMsgColor = TextFormatting.RED;
 
     public EntityPlayer(World world)
     {
@@ -321,12 +334,12 @@ public abstract class EntityPlayer extends EntityLiving
     }
 
     @Override
-    public void onDeath(Entity entity)
+    public void onDeath(Entity entityKilledBy)
     {
         if (getGamemode().isPermaDeath()){
             setGamemode(Gamemode.spectator);
         }
-        super.onDeath(entity);
+        super.onDeath(entityKilledBy);
         setSize(0.2F, 0.2F);
         setPos(x, y, z);
         lastDeathCoordinate = new ChunkCoordinates((int) x, (int) y, (int) z);
@@ -348,7 +361,7 @@ public abstract class EntityPlayer extends EntityLiving
             craftingInventory.onCraftGuiClosed(this);
             inventory.dropAllItems();
         }
-        if(entity != null)
+        if(entityKilledBy != null)
         {
             xd = -MathHelper.cos(((attackedAtYaw + yRot) * 3.141593F) / 180F) * 0.1F;
             zd = -MathHelper.sin(((attackedAtYaw + yRot) * 3.141593F) / 180F) * 0.1F;
@@ -359,6 +372,152 @@ public abstract class EntityPlayer extends EntityLiving
         heightOffset = 0.1F;
         addStat(StatList.deathsStat, 1);
     }
+    @Override
+    public boolean sendDeathMessage(Entity entityKilledBy){
+        return true;
+    }
+    @Override
+    public String getDeathMessage(Entity entityKilledBy){
+        if (random.nextInt(8000) == 666)
+        {
+            return getDisplayName() + deathMsgColor + " was killed by Herobrine.";
+        }
+        if (entityKilledBy instanceof EntityZombie)
+        {
+            if (entityKilledBy instanceof EntityPigZombie)
+            {
+                return getDisplayName() + deathMsgColor + " discovered mob mentality.";
+            }
+            else
+            {
+                return getDisplayName() + deathMsgColor + " became a zombie.";
+            }
+        }
+        if (entityKilledBy instanceof EntityCreeper)
+        {
+            return deathMsgColor + "Aw man, " + getDisplayName() + deathMsgColor + " didn't see the creeper.";
+        }
+        if (entityKilledBy instanceof EntitySkeleton)
+        {
+            return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
+        }
+        if (entityKilledBy instanceof EntitySpider)
+        {
+            return getDisplayName() + deathMsgColor + " spent too much time on the web.";
+        }
+        if (entityKilledBy instanceof EntityGhast)
+        {
+            return getDisplayName() + deathMsgColor + " didn't return the serve.";
+        }
+        if (entityKilledBy instanceof EntitySlime)
+        {
+            return getDisplayName() + deathMsgColor + " was slimed.";
+        }
+        if (entityKilledBy instanceof EntityWolf)
+        {
+            return getDisplayName() + deathMsgColor + " got what they deserved.";
+        }
+        if (entityKilledBy instanceof EntityArrowGolden)
+        {
+            if (((EntityArrowGolden) entityKilledBy).owner instanceof EntityPlayerMP)
+            {
+                if (((EntityPlayerMP) ((EntityArrowGolden) entityKilledBy).owner).username.equals(username))
+                {
+                    return getDisplayName() + deathMsgColor + " got gold in their eye.";
+                }
+                return getDisplayName() + deathMsgColor + " got pierced by " +
+                    ((EntityArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+            }
+            else
+            {
+                return getDisplayName() + deathMsgColor + " is Swiss cheese.";
+            }
+        }
+        if (entityKilledBy instanceof EntityArrow)
+        {
+            if (((EntityArrow) entityKilledBy).owner instanceof EntitySkeleton)
+            {
+                return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
+            }
+            else if (((EntityArrow) entityKilledBy).owner instanceof EntityPlayerMP)
+            {
+                if (((EntityPlayerMP) ((EntityArrow) entityKilledBy).owner).username.equals(username))
+                {
+                    return getDisplayName() + deathMsgColor + " lost a game of Russian roulette.";
+                }
+                return getDisplayName() + deathMsgColor + " got 360 noscoped by " +
+                    ((EntityArrow) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+            }
+            else
+            {
+                return getDisplayName() + deathMsgColor + " is a pincushion.";
+            }
+        }
+        if (entityKilledBy instanceof EntityCannonball)
+        {
+            if (((EntityCannonball) entityKilledBy).owner instanceof EntityPlayerMP)
+            {
+                if (((EntityPlayerMP) ((EntityCannonball) entityKilledBy).owner).username.equals(username))
+                {
+                    return getDisplayName() + deathMsgColor + " jumped too high.";
+                }
+                return getDisplayName() + deathMsgColor + " was fragmented by " +
+                    ((EntityCannonball) entityKilledBy).owner.getDisplayName() + deathMsgColor + ".";
+            }
+            else
+            {
+                return getDisplayName() + deathMsgColor + " was detonated remotely.";
+            }
+        }
+        if (entityKilledBy instanceof EntityFireball)
+        {
+            return getDisplayName() + deathMsgColor + " didn't return the serve.";
+        }
+        if (entityKilledBy instanceof EntityGiant)
+        {
+            return getDisplayName() + deathMsgColor + " was killed by- wait, what?!";
+        }
+        if (entityKilledBy instanceof EntityLightningBolt)
+        {
+            return getDisplayName() + deathMsgColor + " was grounded.";
+        }
+        if (entityKilledBy instanceof EntityTNT)
+        {
+            return getDisplayName() + deathMsgColor + " was killed by Popbob.";
+        }
+        if (entityKilledBy instanceof EntityPlayerMP)
+        {
+            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((EntityPlayerMP) entityKilledBy).getDisplayName() + deathMsgColor + ".";
+        }
+        if (entityKilledBy instanceof EntityPig)
+        {
+            return getDisplayName() + deathMsgColor + " is *really* bad at Minecraft.";
+        }
+        else
+        {
+            if (world.getBlockMaterial(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Material.lava)
+            {
+                return getDisplayName() + deathMsgColor + " got lost in the sauce.";
+            }
+            if (world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Block.spikes.id)
+            {
+                return getDisplayName() + deathMsgColor + " fell for the trap.";
+            }
+            if (fallDistance > 0)
+            {
+                return getDisplayName() + deathMsgColor + " forgot to tie their laces.";
+            }
+            if (airSupply <= 0)
+            {
+                return getDisplayName() + deathMsgColor + " is sleeping with the fishes.";
+            }
+            if (remainingFireTicks > 0)
+            {
+                return getDisplayName() + deathMsgColor + " was cooked well done.";
+            }
+            return getDisplayName() + deathMsgColor + " died mysteriously.";
+        }
+    }
     
     @Override
     protected void dropFewItems()
@@ -739,12 +898,13 @@ public abstract class EntityPlayer extends EntityLiving
         return false;
     }
 
-    public void useCurrentItemOnEntity(Entity entity)
+    public boolean useCurrentItemOnEntity(Entity entity)
     {
+        boolean flag = false;
         if(entity.interact(this))
         {
             swingItem();
-            return;
+            flag = true;
         }
         ItemStack itemstack = getCurrentEquippedItem();
         if(itemstack != null && (entity instanceof EntityLiving))
@@ -752,12 +912,14 @@ public abstract class EntityPlayer extends EntityLiving
             if (itemstack.useItemOnEntity((EntityLiving)entity, this))
             {
                 swingItem();
+                flag = true;
             }
             if(itemstack.stackSize <= 0)
             {
                 destroyCurrentEquippedItem();
             }
         }
+        return flag;
     }
 
     public ItemStack getCurrentEquippedItem()
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
index de6591856..d0db26ae8 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonball.java
@@ -30,7 +30,7 @@ public class EntityCannonball extends EntityProjectile
     public void onHit(HitResult hitResult){
         // Check for block collision
         if (hitResult.hitType == HitResult.HitType.TILE){
-            world.newExplosion(this, x, y, z, 1.5F, false, true);
+            world.newExplosion(owner, x, y, z, 1.5F, false, true);
             remove();
         }
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
index 0a6caff95..92f72557d 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityCannonballBouncy.java
@@ -94,7 +94,7 @@ public class EntityCannonballBouncy extends EntityCannonball
         {
             if (!((collidingEntities != null && collidingEntities.size() == 1) && collidingEntities.get(0) == owner && tickCount < 4))
             {
-                world.newExplosion(this, x, y, z, 1.5F, false, true);
+                world.newExplosion(owner, x, y, z, 1.5F, false, true);
                 remove();
                 return;
             }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
index 251f33b33..a23db3386 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
@@ -85,7 +85,7 @@ public class EntityFireball extends EntityProjectile
                         result.entity.hurt(owner, damage, DamageType.COMBAT);
                     }
                 }
-                world.newExplosion(this, x, y, z, 1.5F, true, false);
+                world.newExplosion(owner, x, y, z, 1.5F, true, false);
             }
             remove();
         }
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 8988e2a48..8eedf4059 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -1,6 +1,11 @@
 package net.minecraft.core.item;
 
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Random;
+
 import com.mojang.nbt.CompoundTag;
+
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.data.tag.ITaggable;
@@ -21,10 +26,6 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Random;
-
 // Referenced classes of package net.minecraft.src:
 //            ItemStack, StatCollector, ItemSpade, EnumToolMaterial, 
 //            ItemPickaxe, ItemAxe, ItemFlintAndSteel, ItemFood, 
@@ -37,6 +38,7 @@ import java.util.Random;
 //            ItemMap, ItemShears, ItemRecord, StatList, 
 //            EntityPlayer, World, EntityLiving, Entity
 
+@SuppressWarnings("unchecked")
 public class Item
     implements ITaggable<Item>, IItemConvertible
 {
@@ -250,6 +252,21 @@ public class Item
     public boolean showFullDurability() {
     	return false;
     }
+
+    @Override
+    public boolean isIn(Tag<Item> tag) {
+        return tag.appliesTo(this);
+    }
+
+    @Override
+    public Item asItem() {
+        return this;
+    }
+
+    @Override
+    public ItemStack getDefaultStack() {
+        return new ItemStack(this);
+    }
     
     protected static Random itemRand = new Random();
     public static final Map<String, Integer> nameToIdMap = new HashMap<>();
@@ -383,7 +400,7 @@ public class Item
     public static Item armorLeggingsSteel = (new ItemArmor("armor.leggings.steel", 16491, ArmorMaterial.STEEL, 2));
     public static Item armorBootsSteel = (new ItemArmor("armor.boots.steel", 16492, ArmorMaterial.STEEL, 3));
 
-    public static Item toolSwordSteel = (new ItemToolSword("tool.sword.steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
+	public static Item toolSwordSteel = (new ItemToolSword("tool.sword.steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelSteel = (new ItemToolShovel("tool.shovel.steel", 16494, ToolMaterial.steel));
     public static Item toolPickaxeSteel = (new ItemToolPickaxe("tool.pickaxe.steel", 16495, ToolMaterial.steel));
     public static Item toolAxeSteel = (new ItemToolAxe("tool.axe.steel", 16496, ToolMaterial.steel));
@@ -436,22 +453,15 @@ public class Item
     protected boolean hasSubtypes;
     private Item containerItem;
     private String key;
+    
     public static void initializeItems(){
         StatList.onItemInit();
     }
-
-    @Override
-    public boolean isIn(Tag<Item> tag) {
-        return tag.appliesTo(this);
-    }
-
-    @Override
-    public Item asItem() {
-        return this;
-    }
-
-    @Override
-    public ItemStack getDefaultStack() {
-        return new ItemStack(this);
+    
+    public static boolean hasTag(ItemStack itemStack, Tag<Item> tag) {
+    	if(itemStack == null) {
+    		return false;
+    	}
+    	return tag.appliesTo(itemsList[itemStack.itemID]);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemFirestriker.java b/src/main/java/net/minecraft/core/item/ItemFirestriker.java
index a9f079511..08636dc7d 100644
--- a/src/main/java/net/minecraft/core/item/ItemFirestriker.java
+++ b/src/main/java/net/minecraft/core/item/ItemFirestriker.java
@@ -5,6 +5,7 @@ package net.minecraft.core.item;
 //            ItemStack, EntityPlayer
 
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.Block;
@@ -17,7 +18,7 @@ public class ItemFirestriker extends Item
     {
         super(name, id);
         maxStackSize = 1;
-        setMaxDamage(128);
+        setMaxDamage(ToolMaterial.iron.getDurability()/2);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/item/ItemFishingRod.java b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
index 4429b3073..e617831de 100644
--- a/src/main/java/net/minecraft/core/item/ItemFishingRod.java
+++ b/src/main/java/net/minecraft/core/item/ItemFishingRod.java
@@ -14,7 +14,7 @@ public class ItemFishingRod extends Item
     public ItemFishingRod(String name, int id)
     {
         super(name, id);
-        setMaxDamage(64);
+        setMaxDamage(196);
         setMaxStackSize(1);
     }
 
diff --git a/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index 2b9658955..c84c929eb 100644
--- a/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -21,15 +21,21 @@ public class ItemPlaceable extends Item {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
+		boolean placedInside = false;
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
+		} else {
+			placedInside = true;
 		}
 		if(blockY < 0 || blockY >= world.getHeightBlocks()) {
 			return false;
 		}
 		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+			if (placedInside){
+				world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+			}
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
 				blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/ItemRope.java b/src/main/java/net/minecraft/core/item/ItemRope.java
index 14b410cda..3154cdbfd 100644
--- a/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -30,15 +30,21 @@ public class ItemRope extends ItemPlaceable{
             }
 
         }
+        boolean placedInside = false;
         if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
             blockX += side.getOffsetX();
             blockY += side.getOffsetY();
             blockZ += side.getOffsetZ();
+        } else {
+            placedInside = true;
         }
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
             return false;
         }
         if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+            if (placedInside){
+                world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+            }
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? 0b1000_0000 : 0)) {
                 blockToPlace.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockToPlace, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 9ef5817b0..86697b6ea 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -34,19 +34,26 @@ public class ItemBlock extends Item
 		if(stack.stackSize <= 0) {
 			return false;
 		}
+        boolean placedInside = false;
 		if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			blockX += side.getOffsetX();
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
-		}
+		} else {
+            placedInside = true;
+        }
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
         	return false;
         }
 		if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
 			Block block = Block.blocksList[blockID];
+            if (placedInside){
+                world.playSoundEffect(2001, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
+            }
 			if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(stack.getMetadata()))) {
 				block.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
+
 			}
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index a6181b7f1..466ffb0ea 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -53,7 +53,11 @@ public class ItemBlockLadder extends ItemBlock {
 	}
 	
 	public boolean placeBlock(World world, int x, int y, int z, int meta, EntityPlayer player, ItemStack stack, Side side, double sideHeight) {
+		Block currentBlock = world.getBlock(x, y, z);
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
+			if (currentBlock != null){
+				world.playSoundEffect(2001, x, y, z, world.getBlockId(x, y, z));
+			}
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				Block.getBlock(blockID).onBlockPlaced(world, x, y, z, side, player, sideHeight);
 				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, blockLadder, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index fcd3349d1..54d70aedd 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -125,8 +125,13 @@ public class ItemBlockLayer extends ItemBlock
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
+			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+			boolean placedInside = currentBlock != null;
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
 			{
+				if (placedInside){
+					world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+				}
 				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index a48d94434..f6b1252ff 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -122,8 +122,13 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
 			final Block block = Block.blocksList[blockID];
-			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata()) | 0b10000000))
+			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+			boolean placedInside = currentBlock != null;
+			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
 			{
+				if (placedInside){
+					world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+				}
 				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index d71455451..94d3a88a3 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -92,8 +92,13 @@ public class ItemBlockSlab extends ItemBlock
         if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
         {
             Block block = Block.blocksList[blockID];
+            Block currentBlock = world.getBlock(blockX, blockY, blockZ);
+            boolean placedInside = currentBlock != null;
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
             {
+                if (placedInside){
+                    world.playSoundEffect(2001, blockX, blockY, blockZ, currentBlock.id);
+                }
             	Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, side, entityplayer, yPlaced);
                 world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/material/ToolMaterial.java b/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
index a68f34288..16625c3e7 100644
--- a/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
+++ b/src/main/java/net/minecraft/core/item/material/ToolMaterial.java
@@ -4,10 +4,10 @@ public class ToolMaterial {
 	
 	public static final ToolMaterial wood = new ToolMaterial().setDurability(64).setEfficiency(2.0f, 4.0f).setMiningLevel(0);
 	public static final ToolMaterial stone = new ToolMaterial().setDurability(128).setEfficiency(4.0f, 6.0f).setMiningLevel(1);
-	public static final ToolMaterial iron = new ToolMaterial().setDurability(256).setEfficiency(6.0f, 8.0f).setMiningLevel(2);
+	public static final ToolMaterial iron = new ToolMaterial().setDurability(384).setEfficiency(6.0f, 8.0f).setMiningLevel(2);
 	public static final ToolMaterial steel = new ToolMaterial().setDurability(4608).setEfficiency(7.0f, 14.0f).setMiningLevel(3);
 	public static final ToolMaterial diamond = new ToolMaterial().setDurability(1536).setEfficiency(14.0f, 45.0f).setMiningLevel(3).setDamage(4).setBlockHitDelay(4);
-	public static final ToolMaterial gold = new ToolMaterial().setDurability(64).setEfficiency(4.0f, 8.0f).setMiningLevel(2).setSilkTouch(true);
+	public static final ToolMaterial gold = new ToolMaterial().setDurability(256).setEfficiency(7.0f, 12f).setMiningLevel(2).setSilkTouch(true);
 	
 	private int miningLevel;
 	private int durability;
diff --git a/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index 559e9155a..7114b752b 100644
--- a/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -22,6 +22,10 @@ public abstract class ItemTags
      * Items with this tag will not be shown in the creative inventory.
      */
     public static Tag<Item> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
+    /**
+     * Blocks like doors and levers should not be interacted with when mining them with an item with this tag
+     */
+    public static Tag<Item> PREVENT_LEFT_CLICK_INTERACTIONS = Tag.of("prevent_left_click_interactions");
 
     public static List<Tag<Item>> TAG_LIST;
 
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemTool.java b/src/main/java/net/minecraft/core/item/tool/ItemTool.java
index 346890440..93c419b57 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemTool.java
+++ b/src/main/java/net/minecraft/core/item/tool/ItemTool.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.world.World;
 
 public class ItemTool extends Item
@@ -16,10 +17,12 @@ public class ItemTool extends Item
 	private final int damageVsEntity;
 	protected ToolMaterial material;
 
+	@SuppressWarnings("unchecked")
 	protected ItemTool(String name, int id, int damageDealt, ToolMaterial toolMaterial, Tag<Block> tagEffectiveAgainst) {
 		super(name, id);
 		this.material = toolMaterial;
 		this.tagEffectiveAgainst = tagEffectiveAgainst;
+		withTags(ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS);
 		
 		maxStackSize = 1;
 		setMaxDamage(toolMaterial.getDurability());
diff --git a/src/main/java/net/minecraft/core/sound/SoundTypes.java b/src/main/java/net/minecraft/core/sound/SoundTypes.java
index 70fe18aeb..5d0b32222 100644
--- a/src/main/java/net/minecraft/core/sound/SoundTypes.java
+++ b/src/main/java/net/minecraft/core/sound/SoundTypes.java
@@ -19,11 +19,14 @@ public class SoundTypes {
 	public static void registerSounds() {
 		register("ambient.cave.cave");
 		register("ambient.weather.thunder");
-		
+		register("ambient.weather.rain");
+
 		register("mob.skeleton");
 		register("mob.skeletonhurt");
 		register("mob.spider");
 		register("mob.spiderdeath");
+		register("mob.slime");
+		register("mob.slimeattack");
 		register("mob.ghast.charge");
 		register("mob.ghast.death");
 		register("mob.ghast.fireball");
@@ -31,6 +34,7 @@ public class SoundTypes {
 		register("mob.ghast.scream");
 		register("mob.zombiepig.zpig");
 		register("mob.zombiepig.zpighurt");
+		register("mob.zombiepig.zpigdeath");
 		register("mob.zombie");
 		register("mob.zombiehurt");
 		register("mob.zombiedeath");
@@ -60,6 +64,8 @@ public class SoundTypes {
 		register("random.breath");
 		register("random.click");
 		register("random.drr");
+		register("random.door_open");
+		register("random.door_close");
 		register("random.explode");
 		register("random.fizz");
 		register("random.fuse");
